/*

$.getJSON( "ajax/test.json", function( data ) {
  var items = [];
  $.each( data, function( key, val ) {
    items.push( "<li id='" + key + "'>" + val + "</li>" );
  });
 
  $( "<ul/>", {
    "class": "my-new-list",
    html: items.join( "" )
  }).appendTo( "body" );
});
*/
var A_SUITE='hadvCalc';    // <- Alle globalen Groessen fangen bei mir mit "A_" an.
var A_APP='crdv';          //    So werden die Bezeichner leichter im Debugger gefunden. Dies spart Zeit!
var A_PRE_STORE_KEY = A_SUITE + '_' + A_APP + '_';
var A_VERSION='1.0.1';        
var A_Path_APP='crdv/';
var A_Path_JS='js/'; 
var A_Path_CSS='css/';     
var A_Path_COMMON_DATA='data/';  // <- Pfad auf die allgemeinen Daten aller WebApp's
var A_Path_APP_DATA='data/';     // <- Spezieller Pfad auf die WebApp-Daten
var A_Cardview = null;

function ajaxFuncCardView(aBtnId,aValueText) {
 var tmpData = "&id=" + aBtnId + "&data=" + encodeURI(aValueText);
 executeAjaxEvent(tmpData, null,"CARDVIEW.DoCardViewAjaxFunc", false, null, false);
 return true;
}

function testVersion() {
 var tmpStoreKey = A_PRE_STORE_KEY + 'Version';
 var tmpStr  = localStorage.getItem(tmpStoreKey);
 if (tmpStr) {
   if (tmpStr !== A_VERSION) {
     // Evtl. gibt es Daten unter einer anderen Version -> Bereinigen!
     var tmpKey;
     for (var i=0; i<localStorage.length; i++) {
       tmpKey = localStorage.key(i);
       if (tmpKey.indexOf(A_PRE_STORE_KEY) === 0) {
         localStorage.removeItem(tmpKey);
	   }
	 }
   }
 }
 else
   localStorage.setItem(tmpStoreKey,A_VERSION);
}

function cardviewShowOk() {
 //>>>
 $('#cardview-show-buttons').hide();
 $('#cardview-wrapper').show();
 $('#cardview-bottom').show();
 $('#cbtn-no').hide();
 $('#cbtn-yes').hide();
 $('#cbtn-ok').show();
 //<<<
}

function cardviewShowChoice() {
 //>>>
 $('#cardview-show-buttons').hide();
 $('#cardview-wrapper').show();
 $('#cardview-bottom').show();
 $('#cbtn-ok').hide();
 $('#cbtn-no').show();
 $('#cbtn-yes').show();
 //<<<
}

function cardviewEnd(aBtn) {
 if (aBtn) {
   $('#cardview-wrapper').hide();
   $('#cardview-bottom').hide();
   if (aBtn.id === "cbtn-ok" || aBtn.id === "cbtn-yes") {
     if (A_Cardview) {
       var tmpPageIdx = A_Cardview.currCard;
	   var tmpSelText = A_Cardview.cards[tmpPageIdx].innerText;
	   //
	   ajaxFuncCardView(aBtn.id,tmpSelText);
       alert('Current Card: ' + tmpSelText);
     }
	 else
       alert('Kein Cardview-Objekt!');
   }
   else {
   }
   //>>>
   $('#cardview-show-buttons').show();
   //<<<
 }
 else
   alert('Kein Button-Objekt bei Cardview!');
};

function cardviewInit(aCat,aDataRefKey) {
 var tmpCardviewData = [];
 var tmpStoreKey = A_PRE_STORE_KEY + aDataRefKey;
 var tmpCardviewStr  = localStorage.getItem(tmpStoreKey);  // Daten schon im LocalStorage enthalten?
 if (tmpCardviewStr) {
   tmpCardviewData = jQuery.parseJSON(tmpCardviewStr);
   A_Cardview = new CardView('#cardview-wrapper', {
     //-- direction: 'h',    
     dataset: tmpCardviewData,
     onUpdateContent: function (el, data) {
            el.querySelector('img').src = data['img'];
            el.querySelector('h3').innerHTML = data['title'];
            el.querySelector('p').innerHTML = data['text'];
     }
   });
 }
 else {
   var tmpDataUrl;
   // 'c': Common; 's': Stammdaten der WebApp; 'a': Spez. Daten der WebApp
   if (aCat === 's') 
     tmpDataUrl = A_Path_APP_DATA + 's/' + aDataRefKey + ".json";
   else if (aCat === 'a') 
     tmpDataUrl = A_Path_APP_DATA + 'a/' + aDataRefKey + ".json";
   else
     tmpDataUrl = A_Path_COMMON_DATA + aDataRefKey + ".json";
   $.getJSON(tmpDataUrl, function( data ) {
      // Ajax-Aufruf war erfolgreich!
      tmpCardviewData = data;
      A_Cardview = new CardView('#cardview-wrapper', {
         //-- direction: 'h',    
         dataset: tmpCardviewData,
         onUpdateContent: function (el, data) {
            el.querySelector('img').src = data['img'];
            el.querySelector('h3').innerHTML = data['title'];
            el.querySelector('p').innerHTML = data['text'];
        }
      });
	  tmpCardviewStr = JSON.stringify(tmpCardviewData);
	  localStorage.setItem(tmpStoreKey,tmpCardviewStr);    // <- Daten als String im LocalStorage speichern
   })
   .fail(function( jqxhr, textStatus, error ) {
      // Ajax-Aufruf fehlerhaft!
      var tmpErr = textStatus + ", " + error;
      console.log( "Ajax-Fehler: " + tmpErr + "; Url: " + tmpDataUrl);
   });
 }
 document.getElementById('cardview-wrapper').addEventListener('touchmove', 
              function (e) { 
                e.preventDefault(); 
              }, false); 
}

